import { Request, Response } from "@foxify/http";
import { Engine } from "./view";
import type Foxify from ".";
declare namespace Server {
    interface Settings extends Foxify.Settings {
        view?: Engine;
    }
    type Listener = (request: Request, response: Response) => void;
    type Callback = (server: Server) => void;
}
declare class Server {
    protected _host: string;
    protected _listening: boolean;
    protected _port: number;
    private readonly _instance?;
    constructor(settings: Server.Settings, listener: Server.Listener);
    get listening(): boolean;
    reload(callback?: Server.Callback): this;
    start(callback?: Server.Callback): this;
    stop(callback?: Server.Callback): this;
}
export = Server;
//# sourceMappingURL=Server.d.ts.map