"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.STATUSES = void 0;
/**
 * @see https://en.wikipedia.org/wiki/List_of_HTTP_status_codes
 */
var HTTP;
(function (HTTP) {
    // 1xx Informational responses
    HTTP[HTTP["CONTINUE"] = 100] = "CONTINUE";
    HTTP[HTTP["SWITCHING_PROTOCOL"] = 101] = "SWITCHING_PROTOCOL";
    HTTP[HTTP["PROCESSING"] = 102] = "PROCESSING";
    HTTP[HTTP["EARLY_HINTS"] = 103] = "EARLY_HINTS";
    // 2xx Success
    HTTP[HTTP["OK"] = 200] = "OK";
    HTTP[HTTP["CREATED"] = 201] = "CREATED";
    HTTP[HTTP["ACCEPTED"] = 202] = "ACCEPTED";
    HTTP[HTTP["NON_AUTHORITATIVE_INFORMATION"] = 203] = "NON_AUTHORITATIVE_INFORMATION";
    HTTP[HTTP["NO_CONTENT"] = 204] = "NO_CONTENT";
    HTTP[HTTP["RESET_CONTENT"] = 205] = "RESET_CONTENT";
    HTTP[HTTP["PARTIAL_CONTENT"] = 206] = "PARTIAL_CONTENT";
    HTTP[HTTP["MULTI_STATUS"] = 207] = "MULTI_STATUS";
    HTTP[HTTP["ALREADY_REPORTED"] = 208] = "ALREADY_REPORTED";
    HTTP[HTTP["IM_USED"] = 226] = "IM_USED";
    // 3xx Redirection
    HTTP[HTTP["MULTIPLE_CHOICES"] = 300] = "MULTIPLE_CHOICES";
    HTTP[HTTP["MOVED_PERMANENTLY"] = 301] = "MOVED_PERMANENTLY";
    HTTP[HTTP["FOUND"] = 302] = "FOUND";
    HTTP[HTTP["SEE_OTHER"] = 303] = "SEE_OTHER";
    HTTP[HTTP["NOT_MODIFIED"] = 304] = "NOT_MODIFIED";
    HTTP[HTTP["USE_PROXY"] = 305] = "USE_PROXY";
    HTTP[HTTP["SWITCH_PROXY"] = 306] = "SWITCH_PROXY";
    HTTP[HTTP["TEMPORARY_REDIRECT"] = 307] = "TEMPORARY_REDIRECT";
    HTTP[HTTP["PERMANENT_REDIRECT"] = 308] = "PERMANENT_REDIRECT";
    // 4xx Client errors
    HTTP[HTTP["BAD_REQUEST"] = 400] = "BAD_REQUEST";
    HTTP[HTTP["UNAUTHORIZED"] = 401] = "UNAUTHORIZED";
    HTTP[HTTP["PAYMENT_REQUIRED"] = 402] = "PAYMENT_REQUIRED";
    HTTP[HTTP["FORBIDEN"] = 403] = "FORBIDEN";
    HTTP[HTTP["NOT_FOUND"] = 404] = "NOT_FOUND";
    HTTP[HTTP["METHOD_NOT_ALLOWED"] = 405] = "METHOD_NOT_ALLOWED";
    HTTP[HTTP["NOT_ACCEPTABLE"] = 406] = "NOT_ACCEPTABLE";
    HTTP[HTTP["PROXY_AUTHENTICATION_REQUIRED"] = 407] = "PROXY_AUTHENTICATION_REQUIRED";
    HTTP[HTTP["REQUEST_TIMEOUT"] = 408] = "REQUEST_TIMEOUT";
    HTTP[HTTP["CONFLICT"] = 409] = "CONFLICT";
    HTTP[HTTP["GONE"] = 410] = "GONE";
    HTTP[HTTP["LENGTH_REQUIRED"] = 411] = "LENGTH_REQUIRED";
    HTTP[HTTP["PRECONDITION_FAILED"] = 412] = "PRECONDITION_FAILED";
    HTTP[HTTP["PAYLOAD_TOO_LARGE"] = 413] = "PAYLOAD_TOO_LARGE";
    HTTP[HTTP["URI_TOO_LONG"] = 414] = "URI_TOO_LONG";
    HTTP[HTTP["UNSUPPORTED_MEDIA_TYPE"] = 415] = "UNSUPPORTED_MEDIA_TYPE";
    HTTP[HTTP["RANGE_NOT_SATISFIABLE"] = 416] = "RANGE_NOT_SATISFIABLE";
    HTTP[HTTP["EXPECTATION_FAILED"] = 417] = "EXPECTATION_FAILED";
    HTTP[HTTP["IM_A_TEAPOT"] = 418] = "IM_A_TEAPOT";
    HTTP[HTTP["MISDIRECET_REQUEST"] = 421] = "MISDIRECET_REQUEST";
    HTTP[HTTP["UNPROCESSABLE_ENTITY"] = 422] = "UNPROCESSABLE_ENTITY";
    HTTP[HTTP["LOCKED"] = 423] = "LOCKED";
    HTTP[HTTP["FAILED_DEPENDENCY"] = 424] = "FAILED_DEPENDENCY";
    HTTP[HTTP["UPGRADE_REQUIRED"] = 426] = "UPGRADE_REQUIRED";
    HTTP[HTTP["PRECONDITION_REQUIRED"] = 428] = "PRECONDITION_REQUIRED";
    HTTP[HTTP["TOO_MANY_REQUESTS"] = 429] = "TOO_MANY_REQUESTS";
    HTTP[HTTP["REQUEST_HEADER_FIELDS_TOO_LARGE"] = 431] = "REQUEST_HEADER_FIELDS_TOO_LARGE";
    HTTP[HTTP["UNAVAILABLE_FOR_LEGAL_REASONS"] = 451] = "UNAVAILABLE_FOR_LEGAL_REASONS";
    // 5xx Server errors
    HTTP[HTTP["INTERNAL_SERVER_ERROR"] = 500] = "INTERNAL_SERVER_ERROR";
    HTTP[HTTP["NOT_IMPLEMENTED"] = 501] = "NOT_IMPLEMENTED";
    HTTP[HTTP["BAD_GATEWAY"] = 502] = "BAD_GATEWAY";
    HTTP[HTTP["SERVICE_UNAVAILABLE"] = 503] = "SERVICE_UNAVAILABLE";
    HTTP[HTTP["GATEWAY_TIMEOUT"] = 504] = "GATEWAY_TIMEOUT";
    HTTP[HTTP["HTTP_VERSION_NOT_SUPPORTED"] = 505] = "HTTP_VERSION_NOT_SUPPORTED";
    HTTP[HTTP["VARIANT_ALSO_NEGOTIATES"] = 506] = "VARIANT_ALSO_NEGOTIATES";
    HTTP[HTTP["INSUFFICIENT_STORAGE"] = 507] = "INSUFFICIENT_STORAGE";
    HTTP[HTTP["LOOP_DETECTED"] = 508] = "LOOP_DETECTED";
    HTTP[HTTP["NOT_EXTENDED"] = 510] = "NOT_EXTENDED";
    HTTP[HTTP["NETWORK_AUTHENTICATION_REQUIRED"] = 511] = "NETWORK_AUTHENTICATION_REQUIRED";
})(HTTP || (HTTP = {}));
exports.default = HTTP;
exports.STATUSES = [
    // 1xx Informational responses
    100,
    101,
    102,
    103,
    // 2xx Success
    200,
    201,
    202,
    203,
    204,
    205,
    206,
    207,
    208,
    226,
    // 3xx Redirection
    300,
    301,
    302,
    303,
    304,
    305,
    306,
    307,
    308,
    // 4xx Client errors
    400,
    401,
    402,
    403,
    404,
    405,
    406,
    407,
    408,
    409,
    410,
    411,
    412,
    413,
    414,
    415,
    416,
    417,
    418,
    421,
    422,
    423,
    424,
    426,
    428,
    429,
    431,
    451,
    // 5xx Server errors
    500,
    501,
    502,
    503,
    504,
    505,
    506,
    507,
    508,
    510,
    511,
];
//# sourceMappingURL=HTTP.js.map