"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertNonNegInt = exports.assertPosInt = exports.assertType = void 0;
const assert_1 = __importDefault(require("assert"));
function assertType(name, type, value) {
    (0, assert_1.default)(typeof value === type, `Expected ${name} to be ${type}, got ${typeof value}`);
}
exports.assertType = assertType;
function assertPosInt(name, value) {
    assertType(name, "number", value);
    (0, assert_1.default)(Number.isInteger(value) && value > 0, `Expected ${name} to be a positive integer, got ${value}`);
}
exports.assertPosInt = assertPosInt;
function assertNonNegInt(name, value) {
    assertType(name, "number", value);
    (0, assert_1.default)(Number.isInteger(value) && value >= 0, `Expected ${name} to be a non-negative integer, got ${value}`);
}
exports.assertNonNegInt = assertNonNegInt;
//# sourceMappingURL=assertions.js.map