import assert from "assert";
export function assertType(name, type, value) {
    assert(typeof value === type, `Expected ${name} to be ${type}, got ${typeof value}`);
}
export function assertPosInt(name, value) {
    assertType(name, "number", value);
    assert(Number.isInteger(value) && value > 0, `Expected ${name} to be a positive integer, got ${value}`);
}
export function assertNonNegInt(name, value) {
    assertType(name, "number", value);
    assert(Number.isInteger(value) && value >= 0, `Expected ${name} to be a non-negative integer, got ${value}`);
}
//# sourceMappingURL=assertions.js.map